//************************************************************************
//This module contains fitness case and functions to compute raw fitness *
//as well as standardized fitness for MultiPlexer Problems               *
//Programmed by NXH.                                                     *
//************************************************************************
#ifndef __MULTIPLEXER__
#define __MULTIPLEXER__

#include<iostream.h>
#include<string.h>
#include<stdio.h>
#include<assert.h>
#include<math.h>
#include<stdlib.h>
#include "gconst.h"
#include "random.h"
#include "stree.h"
#include "grammar.h"
#include  "genetic.h"
#define NUMADDRESS  2
#define NUMVAR  6
#define NUMFITCASE 64
struct _sample{
		 BOOL x[NUMVAR];
		 BOOL y;
		};
typedef struct _sample sample;
sample fitcase[NUMFITCASE];
BOOL SuccPredicate=FALSE;
void SetFitCase()
{
 int i,h,l,t;

 for(i=0;i<NUMFITCASE;i++)
  {
   //change to boonlean
   h=i;
   for(l=0;l<NUMVAR;l++)
    {
     if((h % 2)==1)
       fitcase[i].x[l]=TRUE;
     else
      fitcase[i].x[l]=FALSE;
     h=h/2;
    }
  //compute the address value
   h=0;
   t=1;
   for(l=0;l<NUMADDRESS;l++)
    {
     if(fitcase[i].x[l])
       h=h+t;
     t=t*2;
    }
    fitcase[i].y=fitcase[i].x[h+NUMADDRESS];
  }
}
//Some Boolean function
BOOL IF(BOOL a, BOOL b, BOOL c)
{
 if(a)
  return b;
 else
 return c;
}
BOOL AND(BOOL a, BOOL b)
{
 if (a&&b)
  return TRUE;
 else
  return FALSE;
}
BOOL OR(BOOL a,BOOL b)
{
 if(a||b)
  return TRUE;
 else
  return FALSE;
}
BOOL NOT(BOOL a)
{
 if(!a)
  return TRUE;
 else
 return FALSE;
}
//********************************************************************
//This function compute the function (in tree form) with given input *
//********************************************************************
BOOL Compute(node *st,BOOL x[NUMVAR])
{
 node *p,*q;
 BOOL l,r;
 if (!strcmp(st->name,"a0"))
     return x[0];
  else
    if (!strcmp(st->name,"a1"))
      return x[1];
   else
    if (!strcmp(st->name,"d0"))
     return x[2];
   else
   if (!strcmp(st->name,"d1"))
     return x[3];
   else
     if (!strcmp(st->name,"d2"))
      return x[4];
     else
     if (!strcmp(st->name,"d3"))
      return x[5];
 else //st->name="BOOL"
  {
   p=st->children;
   q=p->sibling;
   if(!strcmp(p->name,"not"))//not
    return NOT(Compute(q,x));
    else
     if(!strcmp(p->name,"if"))
      return IF(Compute(q,x),Compute(q->sibling,x),Compute(q->sibling->sibling,x));
     else
      {
       l=Compute(p,x);
       if(q!=NULL)
	{
	 r=Compute(q->sibling,x);
	 if(!strcmp(q->name,"and"))
	    return AND(l,r);
	 else //OR
	    return OR(l,r);
	}
       else
	return l;
      }
  }
}
//*********************************************
//Compute the raw fitness for an invidual     *
//*********************************************
double ComputeRF(individual st)
{
  double sum=0;
  BOOL t;
  int i;
  int hit;
  hit=0;
  for(i=0;i<NUMFITCASE;i++)
   {
     t=Compute(st.chrom,fitcase[i].x);
     if(t==fitcase[i].y)
     {
      hit++;
      sum++;
     }
   }
   if(hit==NUMFITCASE)
     SuccPredicate=TRUE;
   return sum;
}
//****************************************************************
//This function initializes elementary trees and adjoining table *
//****************************************************************
void LoadTerm()
{
 cout<<endl<<"Loading symbols and grammar rules...";
 //First Initialise Symbol  
 InitSymbol();
 AddSymbol("B",TRUE);
 AddSymbol("if",FALSE);
 AddSymbol("and",FALSE);
 AddSymbol("or",FALSE);
 AddSymbol("not",FALSE);
 AddSymbol("a0",FALSE);
 AddSymbol("a1",FALSE);
 AddSymbol("d0",FALSE);
 AddSymbol("d1",FALSE);
 AddSymbol("d2",FALSE);
 AddSymbol("d3",FALSE);
//Second Initialise the rule set
 InitRuleSet();
 AddRule("B-> if B B B",1.0);
 AddRule("B-> B and B",1.0);
 AddRule("B->  B or B",1.0);
 AddRule("B-> not B",1.0);
 AddRule("B-> a0",1.0);
 AddRule("B-> a1",1.0);
 AddRule("B-> d0",1.0);
 AddRule("B-> d1",1.0);
 AddRule("B-> d2",1.0);
 AddRule("B-> d3",1.0);
//Finally Labeling the rules
 LabelRule();

 cout<<endl<<"Done!";
}
#endif
